var CatEN = [
    {
        cname: 'Algebra', functions: [
            { fname: 'lsolve', description: 'Solves linear equation systems by using forward substitution and returns a column vector.', hint: 'lsolve(L, b)' },
            { fname: 'lup', description: 'Returns the matrix LU decomposition. It calculates this decomposition with partial pivoting.', hint: 'lup(A)' },
            { fname: 'lusolve', description: 'Returns the column vector that solves the linear system A * x = b where A is an [n x n] matrix and b is a [n] column vector.', hint: 'lusolve(A, b)' },
            { fname: 'slu', description: 'Returns the LU decomposition of a sparse matrix. It calculates this decomposition with full pivoting.', hint: 'slu(A, order, threshold)' },
            { fname: 'usolve', description: 'Solves a linear equation system by using backward substitution and returns a column vector.', hint: 'usolve(U, b)' },
        ]
    }, {
        cname: 'Arithmetic', functions: [
            { fname: 'abs', description: 'Returns the absolute value of a number.', hint: 'abs(x)' },
            { fname: 'add', description: 'Calculates the sum of two or more values.', hint: 'add(x, y)' },
            { fname: 'cbrt', description: 'Returns the cubic root of a value.', hint: 'cbrt(x [, allRoots])' },
            { fname: 'ceil', description: 'Rounds a value towards positive infinity.', hint: 'ceil(x)' },
            { fname: 'cube', description: 'Computes the cube of the parameter x.', hint: 'cube(x)' },
            { fname: 'divide', description: 'Computes the division between x and y.', hint: 'divide(x, y)' },
            { fname: 'dotDivide', description: 'Divide each element of matrix x with its analogous element in matrix y.', hint: 'dotDivide(x, y)' },
            { fname: 'dotMultiply', description: 'Multiply each element of matrix x with its corresponding element in matrix y.', hint: 'dotMultiply(x, y)' },
            { fname: 'dotPow', description: 'Calculates the power of each element of matrix x with its analogous element in matrix y.', hint: 'dotPow(x, y)' },
            { fname: 'exp', description: 'Calculates the exponent of a value or matrix.', hint: 'exp(x)' },
            { fname: 'fix', description: 'Rounds a value to the nearest integer towards zero.', hint: 'fix(x)' },
            { fname: 'floor', description: 'Rounds a value to the nearest integer less or equal to it.', hint: 'floor(x)' },
            { fname: 'gcd', description: 'Returns the greatest common divisor between two or more values.', hint: 'gcd(a, b)' },
            { fname: 'hypot', description: 'Returns the hypotenuse of a list of values.', hint: 'hypot(a, b, …)' },
            { fname: 'lcm', description: 'Returns the least common multiple between two or more values.', hint: 'lcm(a, b)' },
            { fname: 'log', description: 'Returns the logarithm of a number, according to its base. If the base is not provided it calculates the natural logarithm of the value.', hint: 'log(x [, base])' },
            { fname: 'log10', description: 'Returns the common logarithm or 10-base logarithm of a value.', hint: 'log10(x)' },
            { fname: 'mod', description: 'Returns the remainder after the division of x by y.', hint: 'mod(x, y)' },
            { fname: 'multiply', description: 'Multiply the values x and y.', hint: 'multiply(x, y)' },
            { fname: 'norm', description: 'Returns the norm of a number, vector or matrix.', hint: 'norm(x [, p])' },
            { fname: 'nthRoot', description: 'Returns the nth root of a value.', hint: 'nthRoot(a)' },
            { fname: 'pow', description: 'Raises element x to the power of element y.', hint: 'pow(x, y)' },
            { fname: 'round', description: 'Rounds x to the nearest integer.', hint: 'round(x [, n])' },
            { fname: 'sign', description: 'Determines the sign of a value. It could be 1 when x >1, -1 when x < 0 and 0 when x ==0.', hint: 'sign(x)' },
            { fname: 'sqrt', description: 'Returns the square root of an element.', hint: 'sqrt(x)' },
            { fname: 'square', description: 'Returns the square of an element.', hint: 'square(x)' },
            { fname: 'subtract', description: 'Computes the subtraction of x and y.', hint: 'subtract(x, y)' },
            { fname: 'unaryMinus', description: 'Negates the value of an element.', hint: 'unaryMinus(x)' },
            { fname: 'unaryPlus', description: 'Returns the positive value of an element.', hint: 'unaryPlus(x)' },
            { fname: 'xgcd', description: 'Returns the extended greatest common divisor between two values.', hint: 'xgcd(a, b)' },
        ]
    }, {
        cname: 'Bitwise', functions: [
            { fname: 'bitAnd', description: 'Returns the bitwise logical operation AND, x & y.', hint: 'bitAnd(x, y)' },
            { fname: 'bitNot', description: 'Returns the bitwise logical operation NOT of x.', hint: 'bitNot(x)' },
            { fname: 'bitOr', description: 'Returns the bitwise logical operation OR, x | y.', hint: 'bitOr(x, y)' },
            { fname: 'bitXor', description: 'Returns the bitwise logical operation XOR, x ^ y.', hint: 'bitXor(x, y)' },
            { fname: 'leftShift', description: 'Returns the left logical shift of x by a y number of bits.', hint: 'leftShift(x, y)' },
            { fname: 'rightArithShift', description: 'Returns the right arithmetic shift of x by a y number of bits.', hint: 'rightArithShift(x, y)' },
            { fname: 'rightLogShift', description: 'Returns the right logical shift of x by a y number of bits.', hint: 'rightLogShift(x, y)' },
        ]
    }, {
        cname: 'Calculus', functions: [
            { fname: 'deriv', description: 'Returns the point differential of a function f at a point x. It only supports one-dimensional functions. Example: deriv(f(x)=2*x^2+1,10).', hint: 'deriv(f,x)' },
            { fname: 'integral', description: 'Calculates a definite integral using the Simpsons rule with adaptative quadrature. Calculates the definite integral of a function f regarding x evaluated from a to b.  Example: integral(f(x)=2*x+1,0,10).', hint: 'integral(f,a,b)' },
            { fname: 'LimL', description: 'Calculates the limit of a function f, at a point x approaching from the left. Example: LimL(f(x)=x^2,7).', hint: 'LimL(f,x)' },
            { fname: 'LimM', description: 'Calculates the limit of a function, f, at a point x approaching from the middle (left and right).  Example: LimM(f(x)=x^2,7).', hint: 'LimM(f,x)' },
            { fname: 'LimR', description: 'Calculates the limit of a function f, at a point x approaching from the right. Example: LimR(f(x)=x^2,7).', hint: 'LimM(f,x)' },
        ]
    }, {
        cname: 'Combinatorics', functions: [
            { fname: 'bellNumbers', description: 'The Bell numbers count the number of partitions in which a set of n elements can be divided.', hint: 'bellNumbers(n)' },
            { fname: 'catalan', description: 'Enumerates a sequence of natural numbers which is very important in combinatorial mathematics since it appears in several counting problems.', hint: 'catalan(n)' },
            { fname: 'composition', description: 'The composition counts of n into k parts.', hint: 'composition(n, k)' },
            { fname: 'stirlingS2', description: 'Counts the number of ways in which a set of n labelled objects could be partitioned into k nonempty subsets.', hint: 'stirlingS2(n, k)' },
        ]
    }, {
        cname: 'Complex', functions: [
            { fname: 'arg', description: 'Calculates the argument of a complex number.', hint: 'arg(x)' },
            { fname: 'conj', description: 'Calculates the conjugate of a complex number.', hint: 'conj(x)' },
            { fname: 'im', description: 'Returns the imaginary part of a complex number.', hint: 'im(x)' },
            { fname: 're', description: 'Returns the real part of a complex number.', hint: 're(x)' },
        ]
    }, {
        cname: 'Geometry', functions: [
            { fname: 'distance', description: 'Calculates the Euclidean distance between two points in 2D or 3D spaces.', hint: 'distance([x1, y1], [x2, y2])' },
            { fname: 'intersect', description: 'Calculates the point of intersection between two lines for 2D and 3D spaces. Calculates the point of intersection of a line and a plane for 3D space.', hint: 'intersect(endPoint1Line1, endPoint2Line1, endPoint1Line2, endPoint2Line2)' },
        ]
    }, {
        cname: 'Logical', functions: [
            { fname: 'and', description: 'Logical operator AND.', hint: 'and(x, y)' },
            { fname: 'not', description: 'Logical operator NOT.', hint: 'not(x)' },
            { fname: 'or', description: 'Logical operator OR.', hint: 'or(x, y)' },
            { fname: 'xor', description: 'Logical operator XOR.', hint: 'xor(x, y)' },
        ]
    }, {
        cname: 'Matrix', functions: [
            { fname: 'concat', description: 'Concatenates two or more matrices according to a specified dimension.', hint: 'concat(a, b, c, … [, dim])' },
            { fname: 'cross', description: 'Evaluates the cross product of two vectors in 3D space.', hint: 'cross(x, y)' },
            { fname: 'det', description: 'Returns the determinant of a matrix.', hint: 'det(x)' },
            { fname: 'diag', description: 'Creates a diagonal matrix or returns the diagonal of a matrix. When x is a vector, the function returns a matrix with elements of x on the main diagonal.', hint: 'diag(X)' },
            { fname: 'dot', description: 'Return the dot product between two vectors.', hint: 'dot(x, y)' },
            { fname: 'eye', description: 'Returns a 2D identity matrix with size m x n or n x n.', hint: 'eye(n)' },
            { fname: 'filter', description: 'Filters the items in an array or one-dimensional matrix according to a function or regular expression.', hint: 'filter(x, test)' },
            { fname: 'flatten', description: 'Transforms a multidimensional matrix into a single dimensional matrix.', hint: 'flatten(x)' },
            { fname: 'forEach', description: 'Executes a callback function for each element of the matrix/array.', hint: 'forEach(x, callback)' },
            { fname: 'inv', description: 'Returns the inverse of a square matrix.', hint: 'inv(x)' },
            { fname: 'map', description: 'Creates a new matrix or array with the results of the callback function executed on each item of the array or array.', hint: 'map(x, callback)' },
            { fname: 'ones', description: 'Creates a matrix or array filled with ones.', hint: 'ones(m, n, p, …)' },
            { fname: 'partitionSelect', description: 'Finds the smallest kth element on a 1D matrix and partitions the array around it.', hint: 'partitionSelect(x, k)' },
            { fname: 'range', description: 'Returns an array of values created from a range.', hint: 'range(start, end [, step])' },
            { fname: 'resize', description: 'Changes the size of a matrix.', hint: 'resize(x, size [, defaultValue])' },
            { fname: 'size', description: 'Returns a vector whose elements denote the length of x (x can be a matrix or scalar).', hint: 'size(x)' },
            { fname: 'sort', description: 'Sort the items in matrix x.', hint: 'sort(x)' },
            { fname: 'squeeze', description: 'Squeeze a matrix by removing its singleton dimensions.', hint: 'squeeze(x)' },
            { fname: 'subset', description: 'Returns a subset of a matrix or string.', hint: 'subset(x, index [, replacement])' },
            { fname: 'trace', description: 'Calculates the trace of a matrix by adding its main diagonal elements.', hint: 'trace(x)' },
            { fname: 'transpose', description: 'Returns the transpose of a matrix.', hint: 'transpose(x)' },
            { fname: 'zeros', description: 'Creates a matrix full of zeros.', hint: 'zeros(m, n, p, …)' },
        ]
    }, {
        cname: 'Probability', functions: [
            { fname: 'combinations', description: 'Returns the number of possible combinations of obtaining an unordered subset of k elements from a set of n objects.', hint: 'combinations(n, k)' },
            { fname: 'factorial', description: 'Returns the factorial of a value. This function only supports an integer value as input.', hint: 'factorial(n)' },
            { fname: 'gamma', description: 'Returns the gamma function of a value. It uses Lanczos approximation for small values and an extended Sterling approximation for larger ones.', hint: 'gamma(n)' },
            { fname: 'kldivergence', description: 'Computes the Kullback-Leibler divergence between distribution x and distribution y.', hint: 'kldivergence(x, y)' },
            { fname: 'multinomial', description: 'Calculates the number of ways to choose a1, a2, …, ai unordered outcomes from n possibilities.', hint: 'multinomial(a)' },
            { fname: 'permutations', description: 'Calculates the number of ways an ordered subset of k elements can be obtained from a set of n elements.', hint: 'permutations(n [, k])' },
            { fname: 'pickRandom', description: 'Returns a random value from a 1D array.', hint: 'pickRandom(array)' },
            { fname: 'random', description: 'Returns a random value that is restrained between the interval [min max] and follows a uniform distribution.', hint: 'random([min, max])' },
            { fname: 'randomInt', description: 'Returns a random integer value that is restrained between the interval [min max] and follows a uniform distribution.', hint: 'randomInt([min, max])' },
        ]
    }, {
        cname: 'Plot', functions: [
            { fname: 'plotFunction', description: 'Adds a f (x) function to the graph list.', hint: 'From the calculator input: plotFunction(x^2+2), from a program script: plotFunction("x^2+2")' },
            { fname: 'plotParametric', description: 'Adds a parametric function to the graph list.', hint: 'From the calculator input: plotParametric(2*cos(t),2*sin(t),0,2*pi), from a program script: plotParametric("2*cos(t)","2*sin(t)",0,2*pi)' },
            { fname: 'plotPolar', description: 'Adds a polar function to the graph list.', hint: 'From the calculator input: plotPolar(2*theta,0,4*pi), from a program script: plotPolar("2*theta",0,4*pi)' },
          //{ fname: 'contour', description: 'Returns a contour plot to represent a 3D surface.', hint: 'contour(f(x,y) = sin(sqrt((x)^2+(y)^2)),-10:0.25:10,-10:0.25:10)' },
            { fname: 'plot', description: 'Creates a 2D plot with the functions in the plot list.', hint: 'plot()' },
            { fname: 'plotXY', description: 'Creates a 2D plot of X vs Y where X and Y are vectors.', hint: 'plotXY(X,Y)' },
            { fname: 'setX', description: 'Sets the X axis limits for the function plot.', hint: 'setX(Xmin,Xmax)' },
            { fname: 'setY', description: 'Sets the Y axis limits for the function plot.', hint: 'largerEq(Ymin, Ymax)' },
            { fname: 'surf', description: 'Returns a 3D surface plot.', hint: 'surf(f(x,y) = sin(sqrt((x)^2+(y)^2)),-10:0.25:10,-10:0.25:10)' },
        ]
    }, {
        cname: 'Program', functions: [
            { fname: 'forEach', description: 'Executes a callback function for each element of the matrix/array.', hint: 'forEach(a,f(x)=eval(i=i+x))' },
            { fname: 'eval', description: 'Evaluates an expression.', hint: 'eval(expr) or eval([expr1, expr2, expr3, ...])' },
            { fname: 'exportVar', description: 'Exports a variable to the global scope.', hint: 'exportVar(varName, varValue)' },
        ]
    }, {
        cname: 'Relational', functions: [
            { fname: 'compare', description: 'Compares x and y.  Returns 1 when x > y, -1 when x < y and 0 when x==y.', hint: 'compare(x, y)' },
            { fname: 'deepEqual', description: 'Compares two matrices element wise to determine if they are equal.', hint: 'deepEqual(x, y)' },
            { fname: 'equal', description: 'Checks if two values are equal.', hint: 'equal(x, y)' },
            { fname: 'larger', description: 'Checks whether value x is larger than value y.', hint: 'larger(x, y)' },
            { fname: 'largerEq', description: 'Checks whether value x is larger or equal to value y.', hint: 'largerEq(x, y)' },
            { fname: 'smaller', description: 'Checks whether value x is smaller than value y.', hint: 'smaller(x, y)' },
            { fname: 'smallerEq', description: 'Checks whether value x is smaller or equal to value y.', hint: 'smallerEq(x, y)' },
            { fname: 'unequal', description: 'Checks whether two values are unequal.', hint: 'unequal(x, y)' },
        ]
    }, {
        cname: 'Statistics', functions: [
            { fname: 'max', description: 'Calculates the maximum value of a matrix or a list of values.', hint: 'max(a, b, c, …)' },
            { fname: 'mean', description: 'Calculates the mean value of a matrix or a list of values.', hint: 'mean(a, b, c, …)' },
            { fname: 'median', description: 'Calculates the median of a matrix or a list of values.', hint: 'median(a, b, c, …)' },
            { fname: 'min', description: 'Calculates the minimum value of a matrix or a list of values.', hint: 'min(a, b, c, …)' },
            { fname: 'mode', description: 'Calculates the mode of a set of numbers.', hint: 'mode(a, b, c, …)' },
            { fname: 'prod', description: 'Calculates the product of a matrix or set of values.', hint: 'prod(a, b, c, …)' },
            {fname: 'quantileSeq', description : 'Compute the prob order quantile of a matrix or a list with values.', hint : 'quantileSeq(A,  prob[, sorted])'},
            { fname: 'std', description: 'Calculates the standard deviation of a matrix or set of values.', hint: 'std(a, b, c, …)' },
            { fname: 'sum', description: 'Calculates the sum of a matrix or a set of values.', hint: 'sum(a, b, c, …)' },
            { fname: 'var', description: 'Calculates the variance of a matrix or set of values.', hint: 'var(a, b, c, …)' },
        ]
    }, {
        cname: 'Trigonometry', functions: [
            { fname: 'acos', description: 'Returns the inverse cosine or arccosine of a value.', hint: 'acos(x)' },
            { fname: 'acosh', description: 'Returns the hyperbolic arccosine of a value, which is defined as acosh(x) = ln(sqrt(x^2 - 1) + x).', hint: 'acosh(x)' },
            { fname: 'acot', description: 'Returns the inverse cotangent or arc cotangent of a value, which is defined as acot(x) = atan(1/x).', hint: 'acot(x)' },
            { fname: 'acoth', description: 'Returns the hyperbolic arc cotangent of a value, which is defined as acoth(x) = atanh(1/x) = (ln((x+1)/x) + ln(x/(x-1))) / 2.', hint: 'acoth(x)' },
            { fname: 'acsc', description: 'Returns the inverse cosecant or arc cosecant of a value, which is defined as acsc(x) = asin(1/x).', hint: 'acsc(x)' },
            { fname: 'acsch', description: 'Returns the hyperbolic arc cosecant of a value, which is defined as acsch(x) = asinh(1/x) = ln(1/x + sqrt(1/x^2 + 1)).', hint: 'acsch(x)' },
            { fname: 'asec', description: 'Returns the inverse secant or arc secant of a value.', hint: 'asec(x)' },
            { fname: 'asech', description: 'Returns the hyperbolic arc secant of a value, which is defined as asech(x) = acosh(1/x) = ln(sqrt(1/x^2 - 1) + 1/x).', hint: 'asech(x)' },
            { fname: 'asin', description: 'Returns the inverse sine or arcsine of a value.', hint: 'asin(x)' },
            { fname: 'asinh', description: 'Returns the hyperbolic arcsine of a value, which is defined as asinh(x) = ln(x + sqrt(x^2 + 1)).', hint: 'asinh(x)' },
            { fname: 'atan', description: 'Returns the arctangent or inverse tangent of a value.', hint: 'atan(x)' },
            { fname: 'atan2', description: 'Returns the inverse tangent function given two arguments, y/x', hint: 'atan2(y, x)' },
            { fname: 'atanh', description: 'Returns the hyperbolic arctangent of a value, which is defined as atanh(x) = ln((1 + x)/(1 - x)) / 2.', hint: 'atanh(x)' },
            { fname: 'cos', description: 'Returns the cosine of a value', hint: 'cos(x)' },
            { fname: 'cosh', description: 'Returns the hyperbolic cosine of a value, which is defined as cosh(x) = 1/2 * (exp(x) + exp(-x)).', hint: 'cosh(x)' },
            { fname: 'cot', description: 'Returns the cotangent of a value.', hint: 'cot(x)' },
            { fname: 'coth', description: 'Returns the hyperbolic cotangent of a value, which is defined as coth(x) = 1 / tanh(x).', hint: 'coth(x)' },
            { fname: 'csc', description: 'Returns the cosecant of a value, which is defined as csc(x) = 1/sin(x).', hint: 'csc(x)' },
            { fname: 'csch', description: 'Returns the hyperbolic cosecant of a value, which is defined as csch(x) = 1 / sinh(x).', hint: 'csch(x)' },
            { fname: 'sec', description: 'Returns the secant of a value, which is defined as sec(x) = 1/cos(x).', hint: 'sec(x)' },
            { fname: 'sech', description: 'Returns the hyperbolic secant of a value, which is defined as sech(x) = 1 / cosh(x).', hint: 'sech(x)' },
            { fname: 'sin', description: 'Returns the sine of a value.', hint: 'sin(x)' },
            { fname: 'sinh', description: 'Returns the hyperbolic sine of a value, which is defined as sinh(x) = 1/2 * (exp(x) - exp(-x)).', hint: 'sinh(x)' },
            { fname: 'tan', description: 'Returns the tangent of a value.', hint: 'tan(x)' },
            { fname: 'tanh', description: 'Returns the hyperbolic tangent of a value, which is defined as tanh(x) = (exp(2 * x) - 1) / (exp(2 * x) + 1).', hint: 'tanh(x)' },
        ]
    },
];


var CatSymEN = [
    {
        cname: 'Arithmetic', functions: [
            { fname: 'abs', description: 'Calculates the absolute value of a number, returns the magnitude of a complex number or returns the length of a vector.', hint: 'abs(x)' },
            { fname: 'ceiling', description: 'Returns the smallest integer value no less than x.', hint: 'ceiling(x)' },
            { fname: 'eval', description: 'Returns the function f evaluated at x=a.', hint: 'eval(f,x,a)' },
            { fname: 'exp', description: 'Calculates the exponential of x.', hint: 'exp(x)' },
            { fname: 'factor', description: 'Returns the factors of integer n.', hint: 'factor(n)' },
            { fname: 'float', description: 'Takes rational numbers or integers and converts them to floating point values.', hint: 'float(x)' },
            { fname: 'floor', description: 'Rounds a value to the nearest integer less or equal to it.', hint: 'floor(x)' },
            { fname: 'gcd', description: 'Returns the greatest common divisor between two or more values.', hint: 'gcd(a,b,...)' },
            { fname: 'isprime', description: 'Determines if a value is a prime number. Returns 1 if n is a prime number or returns zero if it is not.', hint: 'isprime(n)' },
            { fname: 'lcm', description: 'Returns the least common multiple between two or more values.', hint: 'lcm(a,b,...)' },
            { fname: 'log', description: 'Calculates the natural logarithm of x.', hint: 'log(x)' },
            { fname: 'mod', description: 'Returns the remainder after dividing a by b.', hint: 'mod(a,b)' },
            { fname: 'prime', description: 'Calculates the nth prime number. The domain of n is 1 to 10000.', hint: 'prime(n)' },
            { fname: 'product', description: 'Evaluates f for i from j to k and returns the product of all f.', hint: 'product(f,i,j,k)' },
            { fname: 'simplify', description: 'Simplifies x.', hint: 'simplify(x)' },
            { fname: 'sqrt', description: 'Calculates the square root of x', hint: 'sqrt(x)' },
            { fname: 'subst', description: 'Substitutes a for b in c and calculates the result.', hint: 'subst(a,b,c)' },
            { fname: 'sum', description: 'Evaluates f for i equals j through k and returns the sum of all f.', hint: 'sum(f,i,j,k)' },
        ]
    }, {
        cname: 'Calculus', functions: [
            { fname: 'circexp', description: 'Converts circular and hyperbolic functions into exponential forms.', hint: 'circexp(x)' },
            { fname: 'd', description: 'Calculates the partial derivative of f with respect to x', hint: 'd(f,x)' },
            { fname: 'defint', description: 'Calculates the definite integral of f with respect to x and evaluated from a to b. The arguments can be extended for multiple integrals or iterated integrals, for example, defint(f,x,a,b,y,c,d)', hint: 'defint(f,x,a,b)' },
            { fname: 'integral', description: 'Calculates the integral of f with respect to x.', hint: 'integral(f,x)' },
        ]
    }, {
        cname: 'Complex', functions: [
            { fname: 'arg', description: 'Calculates the argument of a complex number.', hint: 'arg(z)' },
            { fname: 'conj', description: 'Calculates the conjugate of a complex number.', hint: 'conj(z)' },
            { fname: 'imag', description: 'Returns the imaginary part of a complex number.', hint: 'imag(z)' },
            { fname: 'mag', description: 'Returns the magnitude of a complex number.', hint: 'mag(z)' },
            { fname: 'polar', description: 'Returns a complex number in polar form.', hint: 'polar(z)' },
            { fname: 'real', description: 'Returns the real part of a complex number.', hint: 'real(z)' },
            { fname: 'rect', description: 'Returns a complex number in rectangular form', hint: 'rect(z)' },
        ]
    }, {
        cname: 'Fractions', functions: [
            { fname: 'denominator', description: 'Calculates the denominator of the expression x.', hint: 'denominator(x)' },
            { fname: 'numerator', description: 'Calculates the numerator of the expression x.', hint: 'numerator(x)' },
            { fname: 'rationalize', description: 'Rationalize x.', hint: 'rationalize(x)' },
        ]
    }, {
        cname: 'Logical', functions: [
            { fname: 'and', description: 'Logical operator AND.', hint: 'and(a,b,...)' },
            { fname: 'check', description: 'If x is true then continue, otherwise stop. Use A=B to verify if A equals B.', hint: 'check(x)' },
            { fname: 'not', description: 'Logical negation of x.', hint: 'not(x)' },
            { fname: 'or', description: 'Logical operator OR.', hint: 'or(a,b,...)' },
        ]
    }, {
        cname: 'Matrix', functions: [
            { fname: 'adj', description: 'Calculates the adjunct of matrix m. The inverse of matrix m is equal to adj(m) divided by det(m).', hint: 'adj(m)' },
            { fname: 'cofactor', description: 'Returns the cofactor ij of matrix m. Let c be the cofactor matrix of m, then transpose(c )= adj(m).', hint: 'cofactor(m,i,j)' },
            { fname: 'contract', description: 'It is the equivalent to the trace of matrix m.', hint: 'contract(a,i,j)' },
            { fname: 'cross', description: 'Calculates the cross product between vectors u and v.', hint: 'cross(u,v)' },
            { fname: 'curl', description: 'Calculates the curl of vector u.', hint: 'curl(u)' },
            { fname: 'det', description: 'Calculates the determinant of matrix m.', hint: 'det(m)' },
            { fname: 'dot', description: 'Calculates the dot product of vectors.', hint: 'dot(a,b,...)' },
            { fname: 'eigen', description: 'Compute eigenvalues and eigen vectors numerically. Argument m must be a numerical and symmetric matrix. This function stores the eigenvalue matrix in D and the eigenvector matrix in Q, so it does not return anything.', hint: 'eigen(m)' },
            { fname: 'eigenval', description: 'Compute eigenvalues and eigen vectors numerically. Argument m must be a numerical and symmetric matrix. This function calculates a matrix with the eigenvalues along the diagonal.', hint: 'eigenval(m)' },
            { fname: 'eigenvec', description: 'Compute eigenvalues and eigen vectors numerically. Argument m must be a numerical and symmetric matrix.  This function calculates the eigenvectors and arranges them as row vectors.', hint: 'eigenvec(m)' },
            { fname: 'hilbert', description: 'Calculates a n by n Hilbert matrix.', hint: 'hilbert(n)' },
            { fname: 'inv', description: 'Calculates the inverse of matrix m.', hint: 'inv(m)' },
            { fname: 'transpose', description: 'Returns the transpose of matrix a with respect to indices i and j. When indices are omitted, 1 and 2 are assumed.', hint: 'transpose(a,i,j)' },
            { fname: 'unit', description: 'Returns an identity matrix with n by n dimensions.', hint: 'unit(n)' },
            { fname: 'zero', description: 'Creates a matrix of all zeros with dimensions i,j, etc.', hint: 'zero(i,j,...)' },
        ]
    }, {
        cname: 'Polynomial', functions: [
            { fname: 'coeff', description: 'Returns the nth coefficient of the polynomial p in the variable x. The argument x can be omitted for single variable polynomials in x.', hint: 'coeff(p,x,n)' },
            { fname: 'deg', description: 'Calculates the degree of polynomial p(x).', hint: 'deg(p,x)' },
            { fname: 'expand', description: 'Expands the polynomial p with respect to x.', hint: 'expand(r,x)' },
            { fname: 'factor', description: 'Factors polynomial p with respect to x. If the polynomial is in x then x can be omitted. The polynomial must be factorable over integers. The argument list can be extended for multivariable polynomials, e.g., factor(p,x,y) so it factors p over x and then over y.', hint: 'factor(p,x)' },
            { fname: 'hermite', description: 'Calculate the nth Hermite polynomial in x.', hint: 'hermite(x,n)' },
            { fname: 'laguerre', description: 'Calculates the nth Laguerre polynomial in x, but if a is omitted, a=0 is assumed.', hint: 'laguerre(x,n,a)' },
            { fname: 'leading', description: 'Returns the leading coefficient of polynomial p in variable x.', hint: 'leading(p,x)' },
            { fname: 'legendre', description: 'Calculates the nth Legendre polynomial in x. If m is omitted, m=0 is assumed.', hint: 'legendre(x,n,m)' },
            { fname: 'nroots', description: 'Calculates all the roots, real and complex of polynomial p in x. These roots are computed numerically. The coefficients of the polynomial can be real or complex.', hint: 'nroots(p,x)' },
            { fname: 'quotient', description: 'Calculates the quotient of two polynomials, p(x) over q(x). If the polynomials are in x, then the last argument can be omitted. The remainder can be calculated as p-q*quotient(p,q)', hint: 'quotient(p,q,x)' },
            { fname: 'roots', description: 'Calculates the values of x such that polynomial p(x)=0. The polynomial must be factorable over integers. For multiple roots the result is a vector. Individual roots can be obtained by component rotation, e.g., r1=roots(p,x)[1].', hint: 'roots(p,x)' },
        ]
    }, {
        cname: 'Probability', functions: [
            { fname: 'choose', description: 'Returns the number of possible combinations of obtaining an unordered subset of k elements from a set of n objects.', hint: 'choose(n,k)' },
            { fname: 'factorial', description: 'Returns the factorial of x. It can be entered as x!', hint: 'factorial(x)' },
        ]
    }, {
        cname: 'Program', functions: [
            { fname: 'do', description: 'Evaluates all the arguments from left to right and returns the result of the last argument.', hint: 'do(a,b,...)' },
            { fname: 'for', description: 'This function works as a loop to repeat a specified number of times according to a counter. The counter is i and repeats the cycle from the integer j through the integer k, evaluating arguments a, then b, etc.', hint: 'for(do(a,b,...),i,j,k)' },
            { fname: 'stop', description: 'Stops the execution of a script.', hint: 'stop()' },
            { fname: 'test', description: 'In this function if the argument \'a\' is true then \'b\' is returned else if argument \'c\' is true then \'d\' is returned and so on.  But if the number of arguments is odd then the last argument will be returned after all else fails.  Use A==B to check if A equals B.', hint: 'test(a,b,c,d,...)' },
        ]
    }, {
        cname: 'Special', functions: [
            { fname: 'besselj', description: 'Bessel function of the first kind.', hint: 'besselj(x,n)' },
            { fname: 'bessely', description: 'Bessel function of the second kind.', hint: 'bessely(x,n)' },
            { fname: 'erf', description: 'Returns the error function of x.', hint: 'erf(x)' },
            { fname: 'erfc', description: 'Returns the complementary error function of x', hint: 'erfc(x)' },
            { fname: 'filter', description: 'Filters f by excluding any terms containing a,b,etc.', hint: 'filter(f,a,b,...)' },
            { fname: 'taylor', description: 'Returns the Taylor expansion of f(x) at x=a. If a is omitted, then a=0 is assumed. The argument n is the degree of the Taylor expansion.', hint: 'taylor(f,x,n,a)' },
        ]
    }, {
        cname: 'Tensor', functions: [
            { fname: 'dim', description: 'Calculates the cardinality of the nth index of tensor a.', hint: 'dim(a,n)' },
            { fname: 'dot', description: 'Returns the dot product of tensors.', hint: 'dot(a,b,...)' },
            { fname: 'inner', description: 'Returns the inner product of tensors, is the same as the dot product.', hint: 'inner(a,b,...)' },
            { fname: 'outer', description: 'Returns the tensor product or outer product of tensors.', hint: 'outer(a,b,...)' },
            { fname: 'rank', description: 'Returns the number of indices of tensor a.', hint: 'rank(a)' },
            { fname: 'shape', description: 'Returns a vector with the shape of the input tensor. If the tensor is a row vector it will return its length, but if the input is a matrix it will return a vector with its dimensions.', hint: 'shape(x)' },
        ]
    }, {
        cname: 'Trigonometry', functions: [
            { fname: 'arccos', description: 'Returns the inverse cosine or arccosine of x.', hint: 'arccos(x)' },
            { fname: 'arccosh', description: 'Returns the hyperbolic arccosine or inverse hyperbolic cosine of x.', hint: 'arccosh(x)' },
            { fname: 'arcsin', description: 'Returns the inverse sine or arcsine of x.', hint: 'arcsin(x)' },
            { fname: 'arcsinh', description: 'Returns the hyperbolic arcsine or inverse hyperbolic sine of x.', hint: 'arcsinh(x)' },
            { fname: 'arctan', description: 'Returns the arctangent or inverse tangent of x.', hint: 'arctan(x)' },
            { fname: 'arctanh', description: 'Returns the hyperbolic arctangent or inverse hyperbolic tangent of x.', hint: 'arctanh(x)' },
            { fname: 'cos', description: 'Calculates the cosine of x.', hint: 'cos(x)' },
            { fname: 'cosh', description: 'Calculates the hyperbolic cosine of x.', hint: 'cosh(x)' },
            { fname: 'expcos', description: 'Calculates the exponential cosine of x.', hint: 'expcos(x)' },
            { fname: 'expsin', description: 'Calculates the exponential sine of x.', hint: 'expsin(x)' },
            { fname: 'sin', description: 'Calculates the sine of x.', hint: 'sin(x)' },
            { fname: 'sinh', description: 'Calculates the hyperbolic sine of x.', hint: 'sinh(x)' },
            { fname: 'tan', description: 'Calculates the tangent of x.', hint: 'tan(x)' },
            { fname: 'tanh', description: 'Calculates the hyperbolic tangent of x.', hint: 'tanh(x)' },
            { fname: 'sec', description: 'Returns the secant of x, which is defined as sec(x) = 1/cos(x).', hint: 'sec(x)' },
            { fname: 'cot', description: 'Returns the cotangent of x. It is defined as cot(x)=1/tan(x).', hint: 'cot(x)' },
            { fname: 'csc', description: 'Returns the cosecant of x, which is defined as csc(x) = 1/sin(x).', hint: 'csc(x)' },
            { fname: 'sech', description: 'Returns the hyperbolic secant of x, which is defined as sech(x) = 1 / cosh(x).', hint: 'sech(x)' },
            { fname: 'coth', description: 'Returns the hyperbolic cotangent of x, which is defined as coth(x) = 1 / tanh(x).', hint: 'coth(x)' },
            { fname: 'csch', description: 'Returns the hyperbolic cosecant of x, which is defined as csch(x) = 1 / sinh(x).', hint: 'csch(x)' },
            { fname: 'acot', description: 'Returns the inverse cotangent or arctangent of x, which is defined as acot(x) = atan(1/x).', hint: 'acot(x)' },
            { fname: 'acoth', description: 'Returns the hyperbolic arc cotangent of x, which is defined as acoth(x) = atanh(1/x).', hint: 'acoth(x)' },
            { fname: 'asec', description: 'Returns the inverse secant or arc secant of x. ', hint: 'asec(x)' },
            { fname: 'asech', description: 'Returns the hyperbolic arc secant of x, which is defined as asech(x) = acosh(1/x).', hint: 'asech(x)' },
            { fname: 'acsc', description: 'Returns the inverse cosecant or arc cosecant of x, which is defined as acsc(x) = asin(1/x).', hint: 'acsc(x)' },
            { fname: 'acsch', description: 'Returns the hyperbolic arc cosecant of x, which is defined as acsch(x) = asinh(1/x).', hint: 'acsch(x)' },
        ]
    }, {
        cname: 'Variable', functions: [
            { fname: 'quote', description: 'Returns the expression without evaluating it first.', hint: 'quote(x)' },
        ]
    },
];
