function getCatalogAsText() {
    var outText = "<table>";
    for (i = 0; i < fCatalog.length; i++) {
        outText += "<tr><td><b>" + fCatalog[i].cname + "<\\b><\\td><\\tr>";
        var j;
        for (j = 0; j < fCatalog[i].functions.length; j++) {
            outText += "<tr>";

            outText += "<td>" + fCatalog[i].functions[j].fname + "<\\td>";
            outText += "<td>" + fCatalog[i].functions[j].description + "<\\td>";

            outText += "<\\tr>";
        }
    }

    return outText + "<\\table>";
}

function getCatalog(sender) {
    var outHtml = "<div id='fcatalog'>";
    var i;
    outHtml += "<h3 class='catalogclassname'>" + getText("Custom") + "</h3>";
    outHtml += "<div>";
    var customCatalog;

    if (config.layoutStyle == "sym") {
        currentCatalog = fCatalogSym;
        customCatalog = customFunctionsSym;
    }
    else {
        currentCatalog = fCatalog;
        customCatalog = customFunctions;
    }

    for (i = 0; i < customCatalog.length; i++) {
        outHtml += "<div class='catalogfunctionname'>" + customCatalog[i].name + "</div>";
        outHtml += "<div class='catalogfunctiondescription'>" + customCatalog[i].name + "(" + customCatalog[i].arguments + ")" + "</div>";
        outHtml += "<div class=\"modalButtonContainer\">";
        outHtml += createButton(customCatalog[i].name, "catalogButton modalButton", "");
        if (sender == "calcButton") {
            outHtml += createButton(getText("Edit"), "catalogEdit modalButton", i.toString());
            outHtml += createButton(getText("Delete"), "catalogDelete modalButton", i.toString());
        }
        outHtml += "</div>";
    }

    outHtml += "</div>";

    for (i = 0; i < currentCatalog.length; i++) {
        outHtml += "<h3 class='catalogclassname'>" + currentCatalog[i].cname + "</h3>";
        outHtml += "<div>";
        var j;
        for (j = 0; j < currentCatalog[i].functions.length; j++) {
            outHtml += "<div class='catalogfunctionname'>" + currentCatalog[i].functions[j].fname + "</div>";
            outHtml += "<div class='catalogfunctiondescription'><b>" + currentCatalog[i].functions[j].hint + "</b></div>";
            outHtml += "<div class='catalogfunctiondescription'>" + currentCatalog[i].functions[j].description + "</div>";
            //outHtml+=createButton(currentCatalog[i].functions[j].fname,"insertFromModal",currentCatalog[i].functions[j].fname+"(","catalogButton");
            outHtml += "<div class=\"modalButtonContainer\">";
            outHtml += createButton(currentCatalog[i].functions[j].fname, "catalogButton modalButton", "");
            outHtml += "</div>";
        }

        outHtml += "</div>";
    }

    outHtml += "</div>";
    return outHtml;
}

function showCatalog(sender) {
    modalPopup(getText("catalog"), getCatalog(sender), "");
    $("#fcatalog").accordion({
        heightStyle: "content",
        autoHeight: false,
        collapsible: true,
        active: false,
        animate: 100
    });
    $('#fcatalog h3').bind('click', function () {
        var self = this;
        setTimeout(function () {
            catOffset = $("#fcatalog").position();
            theOffset = $(self).position();
            $('#modalContent').animate({ scrollTop: theOffset.top - catOffset.top });
            Ps.update(modalContent);
        }, 150); // ensure the collapse animation is done
    });

    $('.catalogEdit').hammer().bind('tap press', function () {

        var pIndex = this.getAttribute("data-exp");
        var customCatalog;

        if (config.layoutStyle == "sym") {
         
            customCatalog = customFunctionsSym;
          


        }
        else {
     
            customCatalog = customFunctions;
            
        }

        document.getElementById('programName').value = customCatalog[pIndex].name;
        document.getElementById('programArguments').value = customCatalog[pIndex].arguments;
        document.getElementById('programCode').value = customCatalog[pIndex].code.replace(/;/gm, ";\n");
        showProgramModal("catalogButton");
        window.setTimeout(function () { modal.style.display = "none"; }, 250);


    });

    $('.catalogDelete').hammer().bind('tap press', function () {
        var pIndex=this.getAttribute("data-exp");

        if (config.layoutStyle == "sym") {
         
            customFunctionsSym.splice(parseInt(pIndex, 10), 1);
            showCatalog("calcButton");
            saveCustomSym();
        }
        else {
         
            customFunctions.splice(parseInt(pIndex, 10), 1);
            showCatalog("calcButton");
            saveCustom();
        }
    });

    $('.catalogButton').hammer().bind('tap press', function () {
        if (sender == "calcButton") {
            insertFromModal(this.innerHTML + '(');
        }
        if (sender == "programButton") {
            insertFromProgramModal($("#programCode"), this.innerHTML + '(');
        }
    });
}