// JavaScript Document




 var Universal_constants=
  {cname: 'Universal_constants', constants: [
  {cname:'speedOfLight',         value : '299792458 m s^-1'},
  {cname:'gravitationConstant',  value : '6.6738480e-11 m^3 kg^-1 s^-2'},
  {cname:'planckConstant',       value : '6.626069311e-34 J s'},
  {cname:'reducedPlanckConstant',value : '1.05457172647e-34 J s'}
  ]};

 var Electromagnetic_constants=
  {cname: 'Electromagnetic_constants', constants: [
  {cname:'magneticConstant',          value : '1.2566370614e-6 N A^-2'},
  {cname:'electricConstant',          value : '8.854187817e-12 F m^-1'},
  {cname:'vacuumImpedance',           value : '376.730313461 ohm'},
  {cname:'coulomb',                   value : '8.9875517873681764e9 N m^2 C^-2'},
  {cname:'elementaryCharge',          value : '1.60217656535e-19 C'},
  {cname:'bohrMagneton',              value : '9.2740096820e-24 J T^-1'},
  {cname:'conductanceQuantum',        value : '7.748091734625e-5 S'},
  {cname:'inverseConductanceQuantum', value : '12906.403721742 ohm'},
  {cname:'magneticFluxQuantum',       value : '2.06783375846e-15 Wb'},
  {cname:'nuclearMagneton',           value : '5.0507835311e-27 J T^-1'},
  {cname:'klitzing',                  value : '25812.807443484 ohm'}
  ]};

 var Atomic_and_nuclear_constants=
  {cname: 'Atomic_and_nuclear_constants', constants: [
  {cname:'bohrRadius',              value : '5.291772109217e-11 m'},
  {cname:'classicalElectronRadius', value : '2.817940326727e-15 m'},
  {cname:'electronMass',            value : '9.1093829140e-31 kg'},
  {cname:'fermiCoupling',           value : '1.1663645e-5 GeV^-2'},
  {cname:'fineStructure',           value : '7.297352569824e-3'},
  {cname:'hartreeEnergy',           value : '4.3597443419e-18 J'},
  {cname:'protonMass',              value : '1.67262177774e-27 kg'},
  {cname:'deuteronMass',            value : '3.3435830926e-27 kg'},
  {cname:'neutronMass',             value : '1.6749271613e-27 kg'},
  {cname:'quantumOfCirculation',    value : '3.636947552024e-4 m^2 s^-1'},
  {cname:'rydberg',                 value : '10973731.56853955 m^-1'},
  {cname:'thomsonCrossSection',     value : '6.65245873413e-29 m^2'},
  {cname:'weakMixingAngle',         value : '0.222321'},
  {cname:'efimovFactor',            value : '22.7'}
  ]};

 var Physico_chemical_constants=
  {cname: 'Physico_chemical_constants', constants: [
  {cname:'atomicMass',          value : '1.66053892173e-27 kg'},
  {cname:'avogadro',            value : '6.0221412927e23 mol^-1'},
  {cname:'boltzmann',           value : '1.380648813e-23 J K^-1'},
  {cname:'faraday',             value : '96485.336521 C mol^-1'},
  {cname:'firstRadiation',      value : '3.7417715317e-16 W m^2'},
  {cname:'loschmidt',           value : '2.686780524e25 m^-3'},
  {cname:'gasConstant',         value : '8.314462175 J K^-1 mol^-1'},
  {cname:'molarPlanckConstant', value : '3.990312717628e-10 J s mol^-1'},
  {cname:'molarVolume',         value : '2.241396820e-10 m^3 mol^-1'},
  {cname:'sackurTetrode',       value : '-1.164870823'},
  {cname:'secondRadiation',     value : '1.438777013e-2 m K'},
  {cname:'stefanBoltzmann',     value : '5.67037321e-8 W m^-2 K^-4'},
  {cname:'wienDisplacement',    value : '2.897772126e-3 m K'}
  ]};

 var Adopted_values=
  {cname: 'Adopted_values', constants: [
  {cname:'molarMass',         value : '1e-3 kg mol^-1'},
  {cname:'molarMassC12',      value : '1.2e-2 kg mol^-1'},
  {cname:'gravity',           value : '9.80665 m s^-2'}
  ]};
 
 var Natural_units=
  {cname: 'Natural_units', constants: [
  {cname:'planckLength',      value : '1.61619997e-35 m'},
  {cname:'planckMass',        value : '2.1765113e-8 kg'},
  {cname:'planckTime',        value : '5.3910632e-44 s'},
  {cname:'planckCharge',      value : '1.87554595641e-18 C'},
  {cname:'planckTemperature', value : '1.41683385e+32 K'}
  ]};


var constantCategories=[Universal_constants,Electromagnetic_constants,Atomic_and_nuclear_constants,Physico_chemical_constants,Adopted_values,Natural_units];


function getConstants()
{
	
	
	var i;
	var outHtml="<div id='fconstants'>";
	for(i=0;i<constantCategories.length;i++)
	{
		
	outHtml+="<h3 class='constantsclassname'>"+constantCategories[i].cname+"</h3>";
	outHtml+="<div>";
	var j;
	
	
	for(j=0;j<+constantCategories[i].constants.length;j++)
	{
		outHtml+="<div class='catalogfunctionname'>"+constantCategories[i].constants[j].cname+"</div>";
		outHtml+="<div class='catalogfunctiondescription'>"+constantCategories[i].constants[j].value+"</div>";
		outHtml+=createButton(constantCategories[i].constants[j].cname,"constantsButton modalButton","");
		
	}
	
	outHtml+="</div>";
	}
	
	outHtml+="</div>";
	return outHtml;
	
	}
	
	
	
function showConstants()
	{
		modalPopup(getText("constants"),getConstants(),"");
		$( "#fconstants" ).accordion({
            heightStyle: "content",
			autoHeight: false,
        collapsible: true,
        active: false,
		animate: 300
     
   });
   Ps.update(modalContent);
   $('.constantsButton').hammer().bind('tap press', function () { insertFromModal(this.innerHTML); });
        
     	
		//alert();
		
		//showCaret();
		}

