// JavaScript Document

function calcSym() {
    calcWorking = true;
    displayStatus();
    caretEnabled = false;
    try {
        clearCaret();
        var calcInput = inputArea.innerHTML;

        calcInput = calcInput.replace(/(\r\n|\n|\r)/gm, "");
        var nmult = calcInput.indexOf(")(");
        if (nmult > -1)
        {
            nmult = nmult + 1;
            throw new Error("Lost operator between )(, position: "+nmult);
        }
        if (calcInput != "") {
            result = Algebrite.run(calcInput);
            addSymToHistory(calcInput, String(result));
            lastAns = String(result);
            setColors(currentSkin);
            if (String(result) == "Stop: integral: sorry, could not find a solution") {
                Algebrite.set_symbols_from_strings(config.symbols);
            }
            else {
                var newSymbols = Algebrite.get_symbols_as_strings()
                config.symbols = newSymbols;
                saveConfig();
            }

            clearInput();
        }
        else {
            calcWorking = false;
            caretEnabled = true;
            displayStatus();
        }
    }
    catch (err) {
        calcWorking = false;
        caretEnabled = true;
        displayStatus();
        alert(err.message);
    }
    caretEnabled = true;
    calcWorking = false;

    //
}

function calc() {
    calcWorking = true;
    displayStatus();
    caretEnabled = false;
    try {
        clearCaret();
        var calcInput = inputArea.innerHTML;

        calcInput = calcInput.replace(/(\r\n|\n|\r)/gm, "");
        if (calcInput != "") {
            //Test specialFunctions
            var i = 0;
            var isSpecialFunction = false;
            var fname;
            var numParams;
            for (i = 0; i < specialFunctions.length; i++) {
                fname = specialFunctions[i].fname;
                numParams = specialFunctions[i].params;
                var patt = new RegExp(fname);
                if (patt.test(calcInput)) {
                    isSpecialFunction = true;
                    break;
                }
            }

            var result;
            if (!isSpecialFunction) {
                result = math.eval(calcInput, config.scope);

                if (result != null) {
                    if (String(result).indexOf("use strict") != -1) {
                        addMathToHistory(calcInput, calcInput);
                    }
                    else {
                        addMathToHistory(calcInput, String(result));
                        lastAns = String(result);
                    }
                }
                else {
                    addMathToHistory(calcInput, calcInput);
                }

                setColors(currentSkin);
                saveConfig();
            }
            else {
                result = evalSpecialFunction(calcInput, fname, numParams);

                addSpecialToHistory(calcInput, result);
                setColors(currentSkin);
            }
            //alert(result);

            clearInput();
        }
        else {
            calcWorking = false;
            caretEnabled = true;
            displayStatus();
        }
    }
    catch (err) {
        calcWorking = false;
        caretEnabled = true;
        displayStatus();
        alert(err.message);
    }
    caretEnabled = true;
    calcWorking = false;

    //
}

function evalSpecialFunction(calcInput, fname, params) {
    if (fname === "sysSolve")
    {
        //result = result.replace(/combinations/g, 'comb');
        calcInput = calcInput.replace(/\[/g, "['");
        calcInput = calcInput.replace(/\]/g, "']");
        calcInput = calcInput.replace(/,/g, "','");
        return "["+eval(calcInput)+"]";
    }

    //Test number of params
    var paramCount = (calcInput.match(/,/g) || []).length + 1;
    if (paramCount != params)
    { return "param error"; }
    calcInput = calcInput.replace("(", "('");
    calcInput = calcInput.substring(0, calcInput.lastIndexOf(")")) + "')";
    var re = new RegExp(",", 'g');
    calcInput = calcInput.replace(re, "','");
    return eval(calcInput);
}