// JavaScript Document
var isCordovaApp = !!window.cordova;
var parenthesis = 'keep';
var implicit = 'hide';
var calcInput = "";
var calcHistory = [];
var lastAns;
var initialized = false;
var opCount = 0;
var plotData = [];
var configReaded = false;
var customReaded = false;
var customSymReaded = false;
var historyReaded = false;
var maxSplashSeconds = 15;
var splashTimeCounter = 0;

//Special functions
var specialFunctions = [];

specialFunctions = specialFunctions.concat(plotFunctions);
specialFunctions = specialFunctions.concat(solveFunctions);

var config = defaultConfig;

Ps.initialize(historyDisplay, {
    suppressScrollX: true,
    theme: 'square'
});
//para modal
Ps.initialize(modalContent, {
    suppressScrollX: true,
    theme: 'square'
});

setLang();

showCaret();

if (!isCordovaApp) {
    initializeSkin();
    if (config.termsAccepted != true) {
        showTerms();
    }
    $("#splashScreenContainer").hide();
}

// PhoneGap is loaded and it is now safe to make calls PhoneGap methods
//
function onDeviceReady() {
    document.addEventListener("backbutton", onBackKeyDown, false);
    admobInit();
    initialized = true;
    try {
        start();
    }
    catch (err) {
        alert(err.message);
    }
}

function hideSplash() {
    navigator.splashscreen.hide();
}

anglesSelector.value = config.angles;
displayStatus();

//start
function start() {
    
    waitForSplash();
    readConfig();
    readHistory();
}

function waitForSplash() {
    console.log("configReaded: " + configReaded + " customReaded: " + customReaded + " customSymReaded: " + customSymReaded + " historyReaded: " + historyReaded);
    if ((configReaded && customReaded && customSymReaded && historyReaded) || maxSplashSeconds * 10 == splashTimeCounter) {
        MathJax.Hub.Queue(function () {
            changeLayout(config.layoutStyle);
            if (config.termsAccepted != true) {
                showTerms();
            }
            $("#splashScreenContainer").hide();
        });
        
        console.log("Start at " + splashTimeCounter*100 + "msec");
    }
    else {
        splashTimeCounter++;
        setTimeout(waitForSplash, 100);
    }

    //
}