//Default config

var currentSkin = colorSkins[0];

var defaultConfig = {
    angles: 'rad', // 'rad', 'deg', 'grad'
    colorSkin: currentSkin,
    layoutStyle: "eva",
    resultFormat: "auto12",
    maxRegs: 30,
    scope: {},
    symbols: [],
    showADS: false,
    termsAccepted: false
};

function changeAngle(angleVal) {
    config.angles = angleVal;

    displayStatus();

    showCaret();

    saveConfig();
}

function changeFormat(format) {
    config.resultFormat = format;

    displayStatus();

    showCaret();

    saveConfig();
}

function getFormat(format) {
    switch (format) {
        case "auto2":
            return { notation: 'auto', precision: 2 };
            break;
        case "auto4":
            return { notation: 'auto', precision: 4 };
            break;
        case "auto6":
            return { notation: 'auto', precision: 6 };
            break;
        case "auto12":
            return { notation: 'auto', precision: 12 };
            break;
        case "auto14":
            return { notation: 'auto', precision: 14 };
            break;
        case "exp2":
            return { notation: 'exponential', precision: 2 };
            break;
        case "exp4":
            return { notation: 'exponential', precision: 4 };
            break;
        case "exp6":
            return { notation: 'exponential', precision: 6 };
            break;
        case "exp12":
            return { notation: 'exponential', precision: 12 };
            break;
        case "exp14":
            return { notation: 'exponential', precision: 14 };
            break;
        case "eng":
            return { notation: 'engineering' };
            break;
        default:
            return config.resultFormat;
    }
}

function configReady(obj) {
    var saveCfg = false;

    if (obj != null) {
        config = obj;
     //   console.log(JSON.stringify(obj));
    }
    else {
        saveCfg = true;
    }

    if (config.termsAccepted == null) {
        config.termsAccepted = defaultConfig.termsAccepted;
        saveCfg = true;
    }

  
        config.showADS = defaultConfig.showADS;
      

    if (config.angles == null) {
        config.angles = defaultConfig.angles;
        saveCfg = true;
    }

    if (config.colorSkin == null) {
        config.colorSkin = defaultConfig.colorSkin;
        saveCfg = true;
    }
    if (config.layoutStyle == null) {
        config.layoutStyle = defaultConfig.layoutStyle;
        saveCfg = true;
    }
    if (config.resultFormat == null) {
        config.resultFormat = defaultConfig.resultFormat;
        saveCfg = true;
    }

    if (config.maxRegs == null) {
        config.maxRegs = defaultConfig.maxRegs;
        saveCfg = true;
    }

    if (config.scope == null) {
        config.scope = defaultConfig.scope;
        saveCfg = true;
    }

    if (config.symbols == null) {
        config.symbols = defaultConfig.symbols;
        saveCfg = true;
    }

    initializeSkin();
    formatSelector.value = config.resultFormat;
    anglesSelector.value = config.angles;
    displayStatus();
    configReaded = true;

    if (saveCfg == true) {
        saveConfig();
    }

    readCustom();
    readCustomSym();

}

function is_touch_device() {
    return 'ontouchstart' in window        // works on most browsers
        || navigator.maxTouchPoints;       // works on IE10/11 and Surface
};

var isMobile = is_touch_device();