// JavaScript Document

var customFunctions = [];
var customFunctionsSym = [];

function isValidName(str) {
    var iChars = "~`!#$%^&*+=-[]\\\';,/{}|\":<>?";

    for (var i = 0; i < str.length; i++) {
        if (iChars.indexOf(str.charAt(i)) != -1) {
            alert("Name has special characters ~`!#$%^&*+=-[]\\\';,/{}|\":<>? \nThese are not allowed\n");
            return false;
        }
    }
    return true;
}

function isValidArg(str) {
    var iChars = "~`!#$%^&*+=-[]\\\';/{}|\":<>?";

    for (var i = 0; i < str.length; i++) {
        if (iChars.indexOf(str.charAt(i)) != -1) {
            alert("Arg has special characters ~`!#$%^&*+=-[]\\\';/{}|\":<>? \nThese are not allowed\n");
            return false;
        }
    }
    return true;
}

function setCustomFunc(fname, args, func, save) {
    if (!isValidName(fname)) {
        return false;
    }

    if (!isValidArg(args)) {
        return false;
    }

    try {
        fname = fname.replace(/(\r\n|\n|\r)/gm, "");
        args = args.replace(/(\r\n|\n|\r)/gm, "");
        func = func.replace(/(\r\n|\n|\r)/gm, "");

        var argsArray = args.split(',');

        var funDefinition = "";
        var i = 0;
        funDefinition += "[";

        for (i = 0; i < argsArray.length; i++) {
            if (argsArray[i] != null && argsArray[i] != '') {
                funDefinition += "'" + argsArray[i] + " = '+arguments[" + i + "],";
            }
        }
        //funDefinition+="'"+func+"']";

        var instructionsArray = func.split(';');

        for (i = 0; i < instructionsArray.length; i++) {
            if (instructionsArray[i] != null && instructionsArray[i] != '') {
                funDefinition += "'" + instructionsArray[i] + "',";
            }
        }

        funDefinition += "]";

        var fnt = "math.import({" + fname + ": function (" + args + ") {var rsp = math.eval(" + funDefinition + "); return rsp[rsp.length-1];}},{override: true})";

        //alert(fnt);
        eval(fnt);

        var customFunction = {
            name: fname,
            arguments: args,
            code: func
        };
        var i;
        for (i = 0; i < customFunctions.length; i++) {
            if (customFunctions[i].name == fname) {
                customFunctions.splice(i, 1);
            }
        }

        customFunctions.push(customFunction);
        if (save) {
            saveCustom();
        }
        return true;
    }
    catch (err) {
        alert(err.message);
        return false;
    }
}

function setCustomFuncSym(fname, args, func, save) {
    if (!isValidName(fname)) {
        return false;
    }

    if (!isValidArg(args)) {
        return false;
    }

    try {
        fname = fname.replace(/(\r\n|\n|\r)/gm, "");
        args = args.replace(/(\r\n|\n|\r)/gm, "");
        func = func.replace(/(\r\n|\n|\r)/gm, "");

        var argsArray = args.split(',');

        var funDefinition = "";
        var i = 0;

        var instructionsArray = func.split(';');

        for (i = 0; i < instructionsArray.length; i++) {
            if (instructionsArray[i] != null && instructionsArray[i] != '') {
                funDefinition += instructionsArray[i] + ",";
            }
        }

        if (funDefinition.slice(-1) == ",") {
            funDefinition = funDefinition.slice(0, -1);
        }
        console.log(fname + "(" + args + ") = do(" + funDefinition + ")");
        Algebrite.run(fname + "(" + args + ") = do(" + funDefinition + ")");

        var customFunction = {
            name: fname,
            arguments: args,
            code: func
        };
        var i;
        for (i = 0; i < customFunctionsSym.length; i++) {
            if (customFunctionsSym[i].name == fname) {
                customFunctionsSym.splice(i, 1);
            }
        }

        customFunctionsSym.push(customFunction);
        if (save) {
            saveCustomSym();
        }
        return true;
    }
    catch (err) {
        alert(err.message);
        return false;
    }
}

function customReady(obj) {
    if (obj != null) {
        var i = 0;
        for (i = 0; i < obj.length; i++) {
            setCustomFunc(obj[i].name, obj[i].arguments, obj[i].code, false);
        }
    }

    customReaded = true;
}

function customSymReady(obj) {
    if (obj != null) {
        var i = 0;
        for (i = 0; i < obj.length; i++) {
            if (setCustomFuncSym(obj[i].name, obj[i].arguments, obj[i].code, false))
            {
                addToAsciiMath(obj[i].name);
            }
        }
        asciimathRefreshSymbols();
    }
    Algebrite.set_symbols_from_strings(config.symbols);
    customSymReaded = true;
}