// JavaScript Document

function createButton(text, styleClass, appenddata) {
    var btnText = "<span  class='" + styleClass + "' data-exp='" + appenddata + "' >" + text + "</span>";
    return btnText;
}

function modalPopup(header, content, footer) {
    var modalHeader = document.getElementById('modalHeader');
    var modalFooter = document.getElementById('modalFooter');
    var mySpan = document.getElementById('modalClose');

    modalContent.innerHTML = content;
    modalHeader.innerHTML = header;
    modalFooter.innerHTML = footer;
    caretEnabled = false;
    ADSBannerShow();
    setColors(currentSkin);

    window.setTimeout(function () { modal.style.display = "block"; }, 250);
    Ps.update(modalContent);

    $(mySpan).hammer().off('tap press');
    $(mySpan).hammer().bind('tap press', function () {
        caretEnabled = true;
        ADSIntersitialShow();
        showCaret();
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
        currentSkin = config.colorSkin;
        setColors(currentSkin);
    });
}

function modalClose()
{
    caretEnabled = true;
    ADSIntersitialShow();
    showCaret();
    window.setTimeout(function () { modal.style.display = "none"; }, 250);
    currentSkin = config.colorSkin;
    setColors(currentSkin);
}

function showProgramModal(sender) {
    $("#codeInput").css("min-height", Math.round(getMinSize() * .8) + "px");
    var mySpan = document.getElementById('programModalClose');

    $("#programNameLabel").text(getText("name"));
    $("#programArgumentsLabel").text(getText("arguments"));
    $("#programCodeLabel").text(getText("code"));

    if (sender == "calcButton") {
        document.getElementById('programName').value = "";
        document.getElementById('programArguments').value = "";
        document.getElementById('programCode').value = "";
    }

    caretEnabled = false;
    ADSBannerShow();

    window.setTimeout(function () { modalProgram.style.display = "block"; }, 250);
    //bprogramEnter

    $(mySpan).hammer().off('tap press');
    $(mySpan).hammer().bind('tap press', function () {
        $('textarea').blur();

        caretEnabled = true;
        ADSIntersitialShow();
        showCaret();
        window.setTimeout(function () { modalProgram.style.display = "none"; }, 250);
    });
}

function modalAlert(errorText) {
    modalPopup(getText("alert"), errorText, "");
}

function showtinv() {
    trigcontainer.style.display = "none";
    tinvcontainer.style.display = "block";
}
function showthyp() {
    thypinvcontainer.style.display = "none";
    thypcontainer.style.display = "block";
}
function showtrig() {
    tinvcontainer.style.display = "none";
    trigcontainer.style.display = "block";
}
function showthypinv() {
    thypcontainer.style.display = "none";
    thypinvcontainer.style.display = "block";
}

function displayConfig() {
    var hideADSLabel = document.getElementById('hideADSLabel');
    var licenseLabel = document.getElementById('configLicenses');
    var bLicenses = document.getElementById('bLicenses');
    var termsLabel = document.getElementById('configTerms');
    var bTerms = document.getElementById('bTerms');
    var skinSelector = document.getElementById('colorSelector');
    var modalHeader = document.getElementById('ConfigHeader');
    var angLabel = document.getElementById('angLabel');
    var formatLabel = document.getElementById('formatLabel');
    var mySpan = document.getElementById('ConfigClose');
    var configADSSection = document.getElementById('configADSSection');
    var bHideAds = document.getElementById('bhADS');
    var bcskin = document.getElementById('bskin');

    if (!config.showADS)
    {
        configADSSection.style.display = "none";
    }

    bLicenses.innerHTML = getText("show");
    bTerms.innerHTML = getText("show");
    bHideAds.innerHTML = getText("Hide_ADS");
    bcskin.innerHTML = getText("Customize_Skin");
    licenseLabel.innerHTML = getText("licenses") + ": ";
    termsLabel.innerHTML = getText("terms_header") + ": ";
    hideADSLabel.innerHTML = getText("ADS") + ": ";
    angLabel.innerHTML = getText("angle") + ": ";
    formatLabel.innerHTML = getText("format") + ": ";
    modalHeader.innerHTML = getText("config");
    formatSelector.value = config.resultFormat;
    anglesSelector.value = config.angles;

    removeOptions(skinSelector);
    tempColorLayout = config.colorSkin;
    var opt;
    var i = 0;
    for (i = 0; i < colorSkins.length; i++) {
        if (currentSkin.skinName != colorSkins[i].skinName) {
            opt = document.createElement("option");
            opt.value = colorSkins[i].skinName;
            opt.innerHTML = colorSkins[i].skinName;
            skinSelector.appendChild(opt);
        }
    }

    opt = document.createElement("option");
    opt.value = currentSkin.skinName;
    opt.innerHTML = currentSkin.skinName;
    skinSelector.appendChild(opt);
    skinSelector.value = currentSkin.skinName;

    caretEnabled = false;
    ADSBannerShow();

    window.setTimeout(function () { configModal.style.display = "block"; }, 250);
    $(mySpan).hammer().off('tap press');
    $(mySpan).hammer().bind('tap press', function () {
        closeConfig();
    });
}
function closeConfig()
{
    caretEnabled = true;
    ADSIntersitialShow()
    showCaret();
    saveSelectedSkin();
    window.setTimeout(function () { configModal.style.display = "none"; }, 250);
}
function getMinSize() {
    var w = $(document).width();
    var h = $(document).height();

    if (h < w) {
        return h;
    }
    else {
        return w;
    }
}

function showIntDer() {
    modalPopup("int/der", createButton("int", "modalButton intButton", "") + createButton("der", "modalButton derButton", ""), "");
    $(".derButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('deriv(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".intButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('integral(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showSolve() {
    modalPopup("Solver", createButton("nsolve", "modalButton solveButton", "") + createButton("sysSolve", "modalButton solveEquationsButton", ""), "");
    $(".solveButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('nsolve(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".solveEquationsButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('sysSolve(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showSymIntDer() {
    modalPopup("int/der", createButton("int", "modalButton intButton", "") + createButton("der", "modalButton derButton", ""), "");
    $(".derButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('d(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".intButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        displayInfo(getText("only_complex_integrals"));
        kbdPress('integral(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showSymMat() {
    modalPopup("Sym Matrix Functions", createButton("dot", "modalButton dotButton", "") + createButton("cross", "modalButton crossButton", "") + createButton("adj", "modalButton adjButton", "") + createButton("cofactor", "modalButton cofactorButton", "") + createButton("det", "modalButton detButton", "") + createButton("eigen", "modalButton eigenButton", "") + createButton("hilbert", "modalButton hilbertButton", "") + createButton("inv", "modalButton invButton", "") + createButton("transpose", "modalButton transposeButton", "") + createButton("unit", "modalButton unitButton", ""), "");

    $(".dotButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('dot(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".crossButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('cross(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".adjButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('adj(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".cofactorButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('cofactor(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".detButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('det(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".eigenButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('eigen(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".hilbertButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('hilbert(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".invButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('inv(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".transposeButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('transpose(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".unitButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('unit(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showSumPro() {
    modalPopup(getText("sum/pro"), createButton("sum", "modalButton sumButton", "") + createButton("product", "modalButton proButton", ""), "");
    $(".sumButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('sum(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".proButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('prod(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showSymSumPro() {
    modalPopup(getText("sum/pro"), createButton("sum", "modalButton sumButton", "") + createButton("product", "modalButton proButton", ""), "");
    $(".sumButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('sum(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".proButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('product(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function showLim() {
    modalPopup("Lim", createButton("Lim", "modalButton limButton", "") + createButton("Lim(+)", "modalButton limRButton", "") + createButton("Lim(-)", "modalButton limLButton", ""), "");
    $(".limButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('limM(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".limRButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('limR(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });

    $(".limLButton").hammer().bind('tap press', function () {
        caretEnabled = true;
        showCaret();
        kbdPress('limL(');
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function removeOptions(selectbox) {
    var i;
    for (i = selectbox.options.length - 1 ; i >= 0 ; i--) {
        selectbox.remove(i);
    }
}