// JavaScript Document
var tempColorLayout;
var buttonLayouts = {
    "sym": { visible: ["#symbolicVars", "#symbolicMath", "#calcSym", "#bCeiling", "#imag", "#real", "#bMag", "#bSymEval", "#rad3", ".symop", ".symconfig"], invisible: ["#plotMenu", "#evalFunctions", "#matsandvects", "#matrixfunc", "#calc", "#bCeil", "#im", "#re", "#log10", "#bConstants", "#cbrt", ".numop", ".spop", ".numconfig"] },
    "eva": { visible: ["#plotMenu", "#evalFunctions", "#calc", "#bCeil", "#im", "#re", "#log10", "#bConstants", "#cbrt", ".numop", ".spop", ".numconfig"], invisible: ["#symbolicVars", "#symbolicMath", "#matsandvects", "#matrixfunc", "#calcSym", "#bCeiling", "#imag", "#real", "#bMag", "#bSymEval", "#rad3", ".symop", ".symconfig"] },
    "mat": { visible: ["#matsandvects", "#matrixfunc", "#calc", "#bCeil", "#im", "#re", "#log10", "#bConstants", "#cbrt", ".numop", ".spop",".numconfig"], invisible: ["#plotMenu", "#evalFunctions", "#symbolicVars", "#symbolicMath", "#calcSym", "#bCeiling", "#imag", "#real", "#bMag", "#bSymEval", "#rad3", ".symop", ".symconfig"] },
};

function viewColorByName(colorSkin) {
    var skinFound = false;
    var i;
    for (i = 0; i < colorSkins.length; i++) {
        var obj = colorSkins[i];
        if (obj.skinName == colorSkin) {
            tempColorLayout = obj;
            skinFound = true;
        }
    }

    if (!skinFound) {
        tempColorLayout = config.colorSkin;
    }

    setColors(tempColorLayout);
}

function changeColor(colorSkin) {
    config.colorSkin = colorSkin;
    setColors(config.colorSkin);
    saveConfig();
}

function changeLayout(n) {
    var i;

    if (buttonLayouts[n] == null) {
        n = defaultConfig.layoutStyle;
    }

    config.layoutStyle = n;

    for (i = 0; i < buttonLayouts[n].invisible.length; i++) {
        $(buttonLayouts[n].invisible[i]).hide();
    }

    for (i = 0; i < buttonLayouts[n].visible.length; i++) {
        $(buttonLayouts[n].visible[i]).show();
    }
    displayStatus();
    Ps.update(historyDisplay);
    historyDisplay.scrollTop = historyDisplay.scrollHeight;
    saveConfig();
}

function initializeSkin() {
    var $leftPanel = $('#leftPannel');
    var $rightPanel = $('#rightPannel');

    var flexcompatible = false;
    var d = document.documentElement.style;
    if (('flexWrap' in d) || ('WebkitFlexWrap' in d) || ('msFlexWrap' in d)) {
        var flexcompatible = true;
    }

    if (flexcompatible) {
        changeLayout(config.layoutStyle);
        setColors(config.colorSkin);
        currentSkin = config.colorSkin;
        $leftPanel.hide().show(0);
        $rightPanel.hide().show(0);
        showCaret();
    }
    else {
        $leftPanel.hide();
        $rightPanel.hide();
        alert("This device is not compatible with the app <br />" + createButton("Close app", "closeAppButton modalButton", ""));
        $('.closeAppButton').hammer().bind('tap press', function () {
            navigator.app.exitApp();
        });
    }
}

function setColors(skin) {
    var obj = skin.skinScheme;
    processSkinScheme(obj);
}

function processSkinScheme(obj) {
    var i = 0;
    for (i = 0; i < obj.length; i++) {
        $(obj[i].object).css(obj[i].attribute, obj[i].value);
        if (obj[i].attribute == 'border-color') {
            $(obj[i].object).css('border-style', 'solid');

            if (obj[i].value == '') {
                //border-style: solid;
                $(obj[i].object).css('border-color', 'transparent');
            }
        }
    }
}

function showSkinModal() {
    var modalContent = "";
    var i = 0;

    for (i = 0; i < colorSkins[0].skinScheme.length; i++) {
        modalContent += "<div style='margin:1vh'>";

        modalContent += colorSkins[0].skinScheme[i].name + " ";
        modalContent += "<span  class='colorPicker modalButton' data-obj='" + colorSkins[0].skinScheme[i].object + "' data-att='" + colorSkins[0].skinScheme[i].attribute + "' >" + getText('change') + "</span>";

        modalContent += "</div>";
    }

    modalPopup(getText("layout"), modalContent, createButton(getText("Save"), "skinSaveButton modalButton", "") + createButton(getText("Cancel"), "skinCancelButton modalButton", ""));
    $(".skinCancelButton").css("margin-top", "0px");
    $(".skinSaveButton").css("margin-top", "0px");
    $(".skinCancelButton").css("margin-bottom", "0px");
    $(".skinSaveButton").css("margin-bottom", "0px");
    $(".skinCancelButton").hammer().bind('tap press', function () {
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
        currentSkin = config.colorSkin;
        setColors(currentSkin);
    });

    $(".skinSaveButton").hammer().bind('tap press', function () {
        saveCurrentSkin();
        console.log("saving");
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
        window.setTimeout(function () { configModal.style.display = "none"; }, 250);
        caretEnabled = true;
    });

    $(".colorPicker").hammer().bind('tap press', function () {
        showColorPickerModal(this);
    });
    /*
	$( ".colorPicker" ).change(function() {
  console.log(this.value);
   });
	*/
}

function setColor(obj, attr, color) {
    if (currentSkin.skinName != "User") {
        currentSkin = jQuery.extend(true, {}, currentSkin)
    }
    var i;
    for (i = 0; i < currentSkin.skinScheme.length; i++) {
        if (currentSkin.skinScheme[i].object == obj && currentSkin.skinScheme[i].attribute == attr) {
            currentSkin.skinScheme[i].value = color;
            currentSkin.skinName = "User";
            //console.log(currentSkin.skinScheme[i]);
        }
    }
    processSkinScheme(currentSkin.skinScheme);
}

function saveCurrentSkin() {
    config.colorSkin = currentSkin;
    saveConfig();
}

function saveSelectedSkin() {
    config.colorSkin = tempColorLayout;
    currentSkin = tempColorLayout;
    saveConfig();
}

function showColorPickerModal(input) {
    var modal = document.getElementById('modalPalette');
    var modalContent = document.getElementById('modalPaletteContent');
    var mySpan = document.getElementById('modalPaletteClose');
    modalContent.innerHTML = createPalete();

    $(".colorButton").hammer().bind('tap press', function () {
        setColor(input.getAttribute("data-obj"), input.getAttribute("data-att"), this.getAttribute("data-color"));

        //inputDiv.innerHTML=this.innerHTML;

        window.setTimeout(function () {
            modal.style.display = "none";
        }, 250);
    });

    window.setTimeout(function () { modal.style.display = "block"; }, 250);

    Ps.update(modalContent);

    $(mySpan).hammer().bind('tap press', function () {
        window.setTimeout(function () { modal.style.display = "none"; }, 250);
    });
}

function createPalete() {
    var content = "";
    var i = 0;
    var j = 0;
    for (j = 0; j < 8; j++) {
        content += "<div class='buttons modalPaletteRow'>";
        for (i = 0; i < 8; i++) {
            content += "<span class='colorButton' data-color='" + colorPalette[8 * j + i] + "' style='background-color:" + colorPalette[8 * j + i] + ";display:block;float:left'>";

            content += "</span>";
        }
        content += "</div>";
    }
    return content;
}

var colorPalette = ['#FFFFFF', '#F5F5F5', '#C0C0C0', '#C8C8A9', '#696969', '#242425', '#303030', '#000000', '#FFFF87', '#FFFF38', '#F7E34B', '#FFF000', '#FFCC00', '#DBB400', '#D3CF00', '#C1BD00', '#F5D3B3', '#D2B48C', '#C3AD62', '#CD853F', '#CEAA40', '#A0522D', '#8B4513', '#603311', '#FFB44E', '#FF6600', '#E07C17', '#D2691E', '#FFA366', '#FF4D4D', '#FF0000', '#800000', '#ADD8E6', '#87CEFA', '#00BFFF', '#1E90FF', '#5F9EA0', '#0000FF', '#191970', '#100348', '#D7ADE6', '#BD87FA', '#B300FF', '#911EFF', '#A05F96', '#E039C1', '#9E0E85', '#4C003F', '#D0E39A', '#91EF91', '#AEFF50', '#00FF00', '#003300', '#9BCA65', '#008B30', '#023814', '#CCFFCC', '#00FF99', '#00CC99', '#00664D', '#5CD2CA', '#00B0A4', '#0A5F56', '#022927'];