// JavaScript Document
var storagePrefix = "mathplusultra";
var configID = "config";
var customID = "custom";
var customSymID = "customSym";
var historyID = "history"

function readHistory() {
    getItem(historyID, historyReady);
}

function saveHistory() {
    saveItem(historyID, calcHistory);
}

function readConfig() {
    getItem(configID, configReady);
}

function saveConfig() {
    saveItem(configID, config);
}

function readCustomSym() {
    getItem(customSymID, customSymReady);
}

function readCustom() {
    getItem(customID, customReady);
}

function saveCustom() {
    saveItem(customID, customFunctions);
}

function saveCustomSym() {
    saveItem(customSymID, customFunctionsSym);
}

function getItem(itemID, functionToExecute) {
    if (initialized) {
        try {
            NativeStorage.getItem(storagePrefix + itemID, function (obj) {
                functionToExecute(obj);
            },
                function (error) {
                    console.log(error.code);
                    if (error.exception !== "")
                    { console.log(error.exception); }
                    functionToExecute(null);
                });
        }
        catch (e) {
            alert(e.message);
            functionToExecute(null);
        }
    }
}

function saveItem(itemID, objectToSave) {
    if (initialized) {
        try {
            NativeStorage.setItem(storagePrefix + itemID, objectToSave, function (obj) {
            },
        function (error) {
            console.log(error.code);
            if (error.exception !== "")
            { console.log(error.exception); }
        });
        }
        catch (e) {
            alert(e.message);
        }
    }
}