var calcWorking = false;
var symDisplay = 4;  // 1 AsciiMath - 2 Tex - 3 Hibrido para fixes - 4 mathjs

function displayText(textToDisplay) {
    showHistory(textToDisplay);
    historyDisplay.style.visibility = "visible";
    Ps.update(historyDisplay);
    historyDisplay.scrollTop = historyDisplay.scrollHeight;
}

function showHistory(divToDisplay) {
    historyDisplay.style.visibility = "hidden";

    historyDisplay.appendChild(divToDisplay);
}

function refreshMathJax(opCount) {
    MathJax.Hub.Queue(["Typeset", MathJax.Hub, "op" + opCount]);
    MathJax.Hub.Queue(function () {
        historyDisplay.style.visibility = "visible";
        historyDisplay.scrollTop = historyDisplay.scrollHeight;
        var targetAns = document.getElementById("ans" + opCount);
        var targetExp = document.getElementById("exp" + opCount);
        Ps.initialize(targetAns, {
            useBothWheelAxes: true,
            suppressScrollY: true,
            theme: 'square'
        });
        Ps.initialize(targetExp, {
            useBothWheelAxes: true,
            suppressScrollY: true,
            theme: 'square'
        });

        $('.mathans').hammer().off('tap');
        $('.mathexp').hammer().off('tap');
        $('.mathans').hammer().bind('tap', function (ev) { ev.stopPropagation(); ev.preventDefault(); mathExpClick(this); });
        $('.mathexp').hammer().bind('tap', function (ev) { ev.stopPropagation(); ev.preventDefault(); mathExpClick(this); });
        detectScrollPosition(targetAns);
        detectScrollPosition(targetExp);
        Ps.update(historyDisplay);
        displayStatus();
    });
}

function clearScreen() {
    /*
    calcHistory
    {calcInput: "$$78$$", result: "$$78$$", rawInput: "78", rawResult: "78", opType: "numop"}
    {calcInput: "`58`", result: "`58`", rawInput: "58", rawResult: "58", opType: "symop"}

    historyDisplay
    .symop
    .numop
    */


    if (config.layoutStyle == "sym") {
       // calcHistory = calcHistory.filter(e => e.opType != "symop");
        calcHistory = calcHistory.filter(function (e) { return e.opType != "symop" });
        var soc = $("#history").children(".symop");
        for (var i = 0; i < soc.length; i++) {

            historyDisplay.removeChild(soc[i]);
        }

    }
    else {
      //  calcHistory = calcHistory.filter(e => e.opType != "numop");
        calcHistory = calcHistory.filter(function (e) { return e.opType != "numop" });
        var noc = $("#history").children(".numop");
        for (var i = 0; i < noc.length; i++) {

            historyDisplay.removeChild(noc[i]);
        }
        calcHistory = calcHistory.filter(function (e) { return e.opType != "spop" });
        noc = $("#history").children(".spop");
        for (var i = 0; i < noc.length; i++) {

            historyDisplay.removeChild(noc[i]);
        }

    }
   
    saveHistory();

    showCaret();
}

function detectScrollPosition(obj) {
    var oWidth = $(obj).width();
    var oScrollWidth = $(obj).prop("scrollWidth");
    var oOffsetWidth = $(obj).prop("offsetWidth");
    var oScrollLeft = $(obj).scrollLeft();
    //Ps.update(obj);

    if (oScrollWidth <= oOffsetWidth) {
        //No Overflow
        $(obj).css('background-image', 'none');
    }
    else {
        //	alert(oScrollWidth+" "+oOffsetWidth);
        if (oScrollLeft == 0) {
            //Scrolled to begin
            $(obj).css('background-image', 'url(' + "images/scrollarrows_right.png" + ')');
            $(obj).css('background-size', 'contain');
            $(obj).css('background-repeat', 'no-repeat');
            $(obj).css('background-position', 'center');
        }
        else {
            if (oScrollLeft >= oScrollWidth - oOffsetWidth - 1) {
                //Scrolled to end
                $(obj).css('background-image', 'url(' + "images/scrollarrows_left.png" + ')');
                $(obj).css('background-size', 'contain');
                $(obj).css('background-repeat', 'no-repeat');
                $(obj).css('background-position', 'center');
            }
            else {
                //medium
                $(obj).css('background-image', 'url(' + "images/scrollarrows_both.png" + ')');
                $(obj).css('background-size', 'contain');
                $(obj).css('background-repeat', 'no-repeat');
                $(obj).css('background-position', 'center');
            }
        }
    }
}

function displayInfo(info) {
    displayInfoText.innerHTML = info;
}
function displayInputParser(cInput) {
    var result = cInput;
    result = result.replace(/combinations/g, 'comb');
    return result;
}

function displayResultParser(result) {
    result = result.replace(/'/g, '&#39;');

    return result;
}

function mathParser(mathExp) {
    var node = null;

    node = math.parse(mathExp);

    var latex = node ? node.toTex({ parenthesis: parenthesis, implicit: implicit }) : '';

    var parsedExp = "$$" + latex + "$$";
    return parsedExp;
}

function addSpecialToHistory(calcInput, result) {
    addToHistory(calcInput, result, calcInput, result,"spop");
}

function addMathToHistory(calcInput, result) {
    var rawInput = calcInput;
    var rawResult = result;

    calcInput = displayInputParser(calcInput);
    calcInput = mathParser(calcInput);

    result = displayResultParser(result);
    //result=mathParser(result);
    try {
        result = mathParser(math.format(math.eval(result), getFormat(config.resultFormat)));
    }
    catch (ex) {
        result = String(rawResult);
    }
    //alert(result);
    addToHistory(calcInput, result, rawInput, rawResult,"numop");
}

function addSymToHistory(calcInput, result) {
    var rawInput = calcInput;
    var rawResult = result;
    calcInput = displayInputParser(calcInput);
    result = displayResultParser(result);

    switch (symDisplay)
    {
        case 1:

            calcInput = "`" + calcInput + "`";
            if (result.indexOf("Stop") == -1) {
             //   result = "`" + result + "`";
            }
            
            break;

        case 2:

            if (result.indexOf("Stop") == -1) {
                calcInput = "$$" + Algebrite.run("printlatex(quote(" + calcInput + "))") + "$$";
                result = "$$" + Algebrite.run("printlatex(quote(" + result + "))") + "$$";
            }
            else {
             //   calcInput = "`" + calcInput + "`";
            }
            break;
        case 3:

            if (result.indexOf("Stop") == -1) {
                result = "$$" + Algebrite.run("printlatex(quote(" + result + "))") + "$$";
                if (result.indexOf("]*[") == -1)
                {
                    calcInput = "`" + calcInput + "`";
                    
                }
                else
                {
                    calcInput = "$$" + Algebrite.run("printlatex(quote(" + calcInput + "))") + "$$";
                }
            }
            else {
             //   calcInput = "`" + calcInput + "`";
            }
            break;
        case 4:

            if (result.indexOf("Stop") == -1) {
                calcInput = "$$" + math.parse(calcInput).toTex({ parenthesis: parenthesis }) + "$$";
                result = "$$" + math.parse(result).toTex({ parenthesis: parenthesis }) + "$$";
            }
            else {
             //   calcInput = "`" + calcInput + "`";
            }
            break;

       
    }


    addToHistory(calcInput, result, rawInput, rawResult,"symop");
}

function checkForMaxRegs() {
   /* if (historyDisplay.childNodes.length > config.maxRegs) {
        historyDisplay.removeChild(historyDisplay.childNodes[0]);
    }
    if (calcHistory.length > config.maxRegs) {
        calcHistory.splice(0, calcHistory.length - config.maxRegs);
    }
    */

    if ($("#history").children(".symop").length > config.maxRegs)
    {
        historyDisplay.removeChild($("#history").children(".symop:first")[0]);
        for (var i = 0; i < calcHistory.length; i++)
        {
            if (calcHistory[i].opType == "symop")
            {
                calcHistory.splice(i, 1);
                break;
            }
        }
    }
    if ($("#history").children(".numop").length > config.maxRegs)
    {
        historyDisplay.removeChild($("#history").children(".numop:first")[0]);
        for (var i = 0; i < calcHistory.length; i++) {
            if (calcHistory[i].opType == "numop") {
                calcHistory.splice(i, 1);
                break;
            }
        }

    }
}

function historyReady(obj) {
    if (obj == null) {
        historyReaded = true;
        return;
    }

    var i = 0;
    console.log(JSON.stringify(obj));
    for (i = 0; i < obj.length; i++) {
        addUnprocessedToHistory(obj[i].calcInput, obj[i].result, obj[i].rawInput, obj[i].rawResult, obj[i].opType)
    }
    MathJax.Hub.Queue(["Typeset", MathJax.Hub, "history"]);
    MathJax.Hub.Queue(function () {
        $(".mathexp").each(function () {
            detectScrollPosition(this);
            $(this).hammer().bind('tap', function (ev) { ev.stopPropagation(); ev.preventDefault(); mathExpClick(this); });
            Ps.initialize(this, {
                useBothWheelAxes: true,
                suppressScrollY: true,
                theme: 'square'
            });
        });

        $(".mathans").each(function () {
            detectScrollPosition(this);
            $(this).hammer().bind('tap', function (ev) { ev.stopPropagation(); ev.preventDefault(); mathExpClick(this); });
            Ps.initialize(this, {
                useBothWheelAxes: true,
                suppressScrollY: true,
                theme: 'square'
            });
        });

        Ps.update(historyDisplay);
        historyDisplay.scrollTop = historyDisplay.scrollHeight;
        historyReaded = true;
    });
}

function addUnprocessedToHistory(calcInput, result, rawInput, rawResult, opType) {
    calcHistory.push({
        calcInput: calcInput,
        result: result,
        rawInput: rawInput,
        rawResult: rawResult,
        opType: opType
    });

    calcInput = calcInput.replace(/'/g, '&#39;');
    result = result.replace(/'/g, '&#39;');
    rawInput = rawInput.replace(/'/g, '&#39;');
    rawResult = rawResult.replace(/'/g, '&#39;');
    opCount++;

    var newdiv = document.createElement('div');
    newdiv.setAttribute('id', 'op' + opCount);

    if (typeof opType !== "undefined") {
        newdiv.setAttribute('class', 'mathop '+opType);
    }
    else
    {
        newdiv.setAttribute('class', 'mathop');
    }
    
    var newdivexp = document.createElement('div');
    newdivexp.setAttribute('id', 'exp' + opCount);
    newdivexp.setAttribute('class', 'mathexp');
    newdivexp.setAttribute('data-exp', rawInput);
    newdivexp.setAttribute('onscroll', 'detectScrollPosition(this)');
    newdivexp.innerHTML = calcInput;

    var newdivans = document.createElement('div');
    newdivans.setAttribute('id', 'ans' + opCount);
    newdivans.setAttribute('class', 'mathans');
    newdivans.setAttribute('data-exp', rawResult);
    newdivans.setAttribute('onscroll', 'detectScrollPosition(this)');
    newdivans.innerHTML = result;

    if (calcInput.indexOf('$$') == -1) {
        //pading 1em
        newdivans.style.paddingTop = "1em";
        newdivans.style.paddingBottom = "1em";

        newdivexp.style.paddingTop = "1em";
        newdivexp.style.paddingBottom = "1em";
    }

    newdiv.appendChild(newdivexp);
    newdiv.appendChild(newdivans);

    displayText(newdiv);
    checkForMaxRegs();
}

function addToHistory(calcInput, result, rawInput, rawResult, opType) {
    addUnprocessedToHistory(calcInput, result, rawInput, rawResult, opType);
    refreshMathJax(opCount);
    saveHistory();
}

function addTextToHistory(text) {
    textToDisplay = text.replace(/'/g, '&#39;');
    opCount++;
    var newdiv = document.createElement('div');
    newdiv.setAttribute('id', 'op' + opCount);
    newdiv.setAttribute('class', 'mathop');
    newdiv.innerText = textToDisplay;
    displayText(newdiv);
}

function bodyResize() {
    if (plotPopup.style.display == "block") {
       // alert();
        plot();
    }

    if (plotPopup3D.style.display == "block") {
        var width = $("#plotPopupContent3D").width();
        var height = $("#plotPopupContent3D").height();

        var update = {
            width: width,
            height: height
        };
        Plotly.relayout('plot3D', update);
    }

    $(".mathexp").each(function () {
        detectScrollPosition(this);
        Ps.update(this);
    }

	);
    $(".mathans").each(function () {
        detectScrollPosition(this);
        Ps.update(this);
    }

	);

    Ps.update(historyDisplay);
}

function mathExpClick(sender) {
    var expContent = sender.getAttribute("data-exp").replace(/`/g, '');

    modalPopup(getText("expression") + ": " + expContent, createButton(getText("toInput"), "modalInsertButton modalButton", "") + createButton(getText("share"), "modalShareButton modalButton", "") + createButton(getText("shareScreen"), "modalShareScreenButton modalButton", ""), "");
    $('.modalInsertButton').hammer().off('tap press');
    $('.modalInsertButton').hammer().bind('tap press', function (ev) { ev.stopPropagation(); ev.preventDefault(); insertFromModal(expContent); });
    $('.modalShareButton').hammer().off('tap press');
    if (sender.innerHTML.indexOf("MathJax")>-1) {
        $('.modalShareButton').hammer().bind('tap press', function (ev) {
            ev.stopPropagation(); ev.preventDefault(); window.setTimeout(function () { modal.style.display = "none"; caretEnabled = true; showCaret(); shareImage(sender.children[0].children[0], expContent); }, 250)
        });
    }
    else
    {
        $('.modalShareButton').hammer().bind('tap press', function (ev) {
            ev.stopPropagation(); ev.preventDefault(); window.setTimeout(function () { modal.style.display = "none"; caretEnabled = true; showCaret(); shareImage(sender, expContent); }, 250)
        });

    }

    $('.modalShareScreenButton').hammer().off('tap press');
    $('.modalShareScreenButton').hammer().bind('tap press', function (ev) { ev.stopPropagation(); ev.preventDefault(); window.setTimeout(function () { modal.style.display = "none"; caretEnabled = true; showCaret(); shareImage(document.body, "Math Plus Ultra"); }, 250) });
    }

function displayStatus() {
    var textToDisplay = "";

    if (config.layoutStyle != "sym") {
        textToDisplay = "NUM " + config.angles + " " + config.resultFormat;
    }
    else {
        textToDisplay = "SYM (" + getText("rad_only") + ") " + getText("complex");
    }

    if (calcWorking) {
        textToDisplay += " " + getText("working");
    }

    statusDisplay.innerHTML = textToDisplay;
}

(function (proxied) {
    window.alert = function (str) {
        // do something here
        modalAlert(str);
        return null;
    };
})(window.alert);