// JavaScript Document
var caretChar = "|";
var secondaryCaretChar = "◊";
var bksPressed = false;
var leftPressed = false;
var rightPressed = false;
var caretCharVisible = true;
var caretPos = 0;
var primaryCaret = true;
var caretEnabled = true;
var caretIsDisplayed = 0;
var charList = "abcdefghijklmnopqrstuvwxyz";
var charEspList = ";+-*/[]{}()=.,^";

var myCaretTimer = setInterval(showCaret, 500);

inputArea.onclick = function () {
    showCaret();
};

function clearCaret() {
    var rexp = new RegExp(escapeRegExp(caretChar), "gm");
    inputArea.innerHTML = inputArea.innerHTML.replace(rexp, "");

    //secondaryCaretChar

    rexp = new RegExp(escapeRegExp(secondaryCaretChar), "gm");
    inputArea.innerHTML = inputArea.innerHTML.replace(rexp, "");
    caretIsDisplayed = 0;
}

function showCaret() {
    if (configModal.style.display != "block") {
        if (caretEnabled) {
            //primaryCaret
            ADSBannerHide();
            clearCaret();
            primaryCaret = !primaryCaret;
            var caretToShow;

            if (primaryCaret) {
                caretToShow = caretChar;
            }
            else {
                caretToShow = secondaryCaretChar;
            }

            insertAtCaret(caretToShow);

            if (caretPos > 0) {
                caretPos = caretPos - 1;
            }
            //
            caretIsDisplayed = 1;
            scrollToCaret();
        }
    }
}

function scrollToCaret() {
    var $textarea = $("#calcInput");

    var w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0)
    var charSize = w * 3 / 100;
    var caretPosition = caretPos;
    var iWidth = $textarea.outerWidth();
    $textarea.scrollLeft(caretPosition * $textarea.height() * .45 - iWidth / 2);
    //console.log();
}

function clearInput() {
    inputArea.innerHTML = "";
    caretPos = 0;
    displayInfo('');
}

function insertAtCaret(text) {
    var $txt = jQuery(inputArea);
    var textAreaTxt = $txt.html();
    $txt.html(textAreaTxt.substring(0, caretPos) + text + textAreaTxt.substring(caretPos));
    caretPos += text.length;
}

function insertToTextarea(jqTextarea, newText) {
    var start = jqTextarea.prop("selectionStart");
    var end = jqTextarea.prop("selectionEnd");
    var text = jqTextarea.val();
    var before = text.substring(0, start);
    var after = text.substring(end, text.length);
    jqTextarea.val(before + newText + after);
    jqTextarea[0].selectionStart = jqTextarea[0].selectionEnd = start + newText.length;
    jqTextarea.focus();
}

function insertAns() {
    if (lastAns != null) {
        kbdPress(lastAns);
    }
}

function kbdPress(buttonVal) {
    insertAtCaret(buttonVal);

    //
    showCaret();
}

function insertFromModal(text) {
    kbdPress(text);

    window.setTimeout(function () { modal.style.display = "none"; }, 250);
    caretEnabled = true;
    showCaret();
}

function insertFromProgramModal(obj, text) {
    insertToTextarea(obj, text);

    caretEnabled = true;
    showCaret();
    window.setTimeout(function () { modal.style.display = "none"; }, 250);
}

function cursorLeft() {
    var txtarea = inputArea;

    if (caretPos > 0) {
        caretPos = caretPos - 1;
    }

    showCaret();
}

function cursorRight() {
    var txtarea = inputArea;

    if (caretPos + caretIsDisplayed < txtarea.innerHTML.length) {
        caretPos = caretPos + 1;
    }

    showCaret();
}

function leftDown() {
    if (!leftPressed) {
        leftPressed = true;
        cursorLeft();
        var leftWait = setTimeout(checkleftHold, 500);
    }
}

function checkleftHold() {
    if (leftPressed == true) {
        var leftRepeat = setInterval(function () {
            if (leftPressed == false) {
                clearInterval(leftRepeat);
            }
            else {
                cursorLeft();
            }
        }, 100);
    }
}

function leftUp() {
    leftPressed = false;
}

function rightDown() {
    if (!rightPressed) {
        rightPressed = true;
        cursorRight();
        var rightWait = setTimeout(checkrightHold, 500);
    }
}

function checkrightHold() {
    if (rightPressed == true) {
        var rightRepeat = setInterval(function () {
            if (rightPressed == false) {
                clearInterval(rightRepeat);
            }
            else {
                cursorRight();
            }
        }, 100);
    }
}

function rightUp() {
    rightPressed = false;
}

function bksDown() {
    if (!bksPressed) {
        bksPressed = true;
        kbdBackspace();
        var bksWait = setTimeout(checkBksHold, 500);
    }
}

function checkBksHold() {
    if (bksPressed == true) {
        var bksRepeat = setInterval(function () {
            if (bksPressed == false) {
                clearInterval(bksRepeat);
            }
            else {
                kbdBackspace();
            }
        }, 100);
    }
}

function bksUp() {
    bksPressed = false;
}

function kbdBackspace() {
    var field = inputArea;

    if (caretPos) {
        field.innerHTML = field.innerHTML.substring(0, caretPos - 1) + field.innerHTML.substring(caretPos, field.innerHTML.length);

        caretPos = caretPos - 1;
    }
    showCaret();
}

function inputclick() {
    //var FF = (document.getBoxObjectFor != null || window.mozInnerScreenX != null);

    //if (FF) {
    inputArea.blur();
    //}
}

function showChars(sender) {
    if (sender == "calcButton") {
        modalPopup(getText("chars"), getChars(), "");
    }
    else
    {
        modalPopup(getText("chars"), getEspChars(), "");
    }
    Ps.update(modalContent);
    $('.charButton').hammer().bind('tap press', function (ev) {
        var chText;
        if (ev.type == 'tap') {
            chText = this.innerHTML;
        }
        else {
            chText = this.innerHTML.toUpperCase();
        }

        if (sender == "calcButton") {
            insertFromModal(chText);
        }
        if (sender == "programButton") {
            insertFromProgramModal($("#programCode"), chText);
        }
    });
}

function getChars() {
    var i;
    var outHtml = "<div class=\"modalButtonContainer\">";
    for (i = 0; i < charList.length; i++) {
        outHtml += createButton(charList[i], "charButton modalButton", "");
    }
    outHtml += "</div>";
    return outHtml;
}

function getEspChars() {
    var i;
    var outHtml = "<div class=\"modalButtonContainer\">";
    for (i = 0; i < charEspList.length; i++) {
        outHtml += createButton(charEspList[i], "charButton modalButton", "");
    }
    outHtml += "</div>";
    return outHtml;
}