function escapeRegExp(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
}

function objToString(obj, ndeep) {
    switch (typeof obj) {
        case "string": return '"' + obj + '"';
        case "function": return obj.name || obj.toString();
        case "object":
            if (obj == null) {
                return "null";
            }
            var indent = Array(ndeep || 1).join('\t'), isArray = Array.isArray(obj);
            return ('{['[+isArray] + Object.keys(obj).map(function (key) {
                return '\n\t' + indent + (isArray ? '' : key + ': ') + objToString(obj[key], (ndeep || 1) + 1);
            }).join(',') + '\n' + indent + '}]'[+isArray]).replace(/[\s\t\n]+(?=(?:[^\'"]*[\'"][^\'"]*[\'"])*[^\'"]*$)/g, '');
        default: return obj.toString();
    }
}
